<template>
  <section class="section">
    <div class="container">
      <div v-if="$apollo.loading">Loading...</div>
      <div v-else class="columns is-centered">
        <div class="column is-5">
          <h3 class="title form-title">{{ form.name }} Issue Form</h3>
          <hr>
          <form @submit.prevent class="form">
            <b-field label="Title">
              <b-input v-model="issue.name" />
            </b-field>
            <b-field label="Message">
              <b-input v-model="issue.description" maxlength="500" type="textarea" />
            </b-field>
            <p class="help is-success">You can use Markdown!</p>
            <button class="button is-warning is-outline is-pulled-right" @click="checkIssue">Create Issue</button>
          </form>
        </div>
      </div>
    </div>
  </section>
</template>

<script>
import FORM_QUERY from '@/graphql/Form/Form.gql'
import CREATE_ISSUE_MUTATION from '@/graphql/Form/CreateIssue.gql'
export default {
  props: { slug: String },
  data: () => ({
    issue: {}
  }),
  apollo: {
    form: {
      query: FORM_QUERY,
      variables () {
        return {
          id: this.slug
        }
      }
    }
  },
  methods: {
    checkIssue () {
      if (!this.issue.name || !this.issue.description) {
        this.$dialog.alert({
          title: 'Error',
          message: `Whoops! Please fill in all required fields.`,
          type: 'is-danger',
          hasIcon: true,
          icon: 'times-circle'
        })
      } else this.createIssue()
    },
    createIssue () {
      this.$apollo.mutate({
        mutation: CREATE_ISSUE_MUTATION,
        variables: {
          userId: this.form.user.id,
          projectId: this.form.projectId,
          ...this.issue
        }
      }).then(({ data: { createIssue } }) => {
        this.$toast.open({
          message: 'Issue Created!',
          type: 'is-success'
        })
        this.issue = {}
      }).catch(err => {
        console.error(err)
        this.$toast.open({
          duration: 5000,
          message: `Something's not good!`,
          type: 'is-danger'
        })
      })
    }
  }
}
</script>

<style lang="scss" scoped>
.form-title {
  text-transform: capitalize;
}
</style>
